#include <iostream>
#include <fstream>

#include "antlr4-runtime.h"
#include "ExprLabeledLexer.h"
#include "ExprLabeledParser.h"
#include "Executor.h"

using namespace antlrcpp;
using namespace antlr4;
using namespace std;

int main(int argc, const char *args[])
{
    ifstream source;

    // Create the input stream.
    source.open(args[1]);
    ANTLRInputStream input(source);

    // Create a lexer which scans the input stream
    // to create a token stream.
    ExprLabeledLexer lexer(&input);
    CommonTokenStream tokens(&lexer);

    // Create a parser which parses the token stream
    // to create a parse tree.
    ExprLabeledParser parser(&tokens);
    tree::ParseTree *tree = parser.program();

    // Execution.
    cout << "Execution:" << endl;
    Executor executor;
    executor.visit(tree);

    return 0;
}
